/***************************************************************************/
/*                         kafskonqplugin.h  -  description                */
/*                           -------------------                           */
/*  begin                : Mon Jan 13 21:48:25 CST 2003                    */
/*  copyright            : (C) 2003 by Ken Aaker                           */
/*  email                : kenaaker@screaminet.com                         */
/***************************************************************************/

/***************************************************************************/
/*                                                                         */
/*   This program is free software; you can redistribute it and/or modify  */
/*   it under the terms of the GNU General Public License as published by  */
/*   the Free Software Foundation; either version 2 of the License, or     */
/*   (at your option) any later version.                                   */
/*                                                                         */
/***************************************************************************/
#ifndef __plugin_kafskonqplugin_h
#define __plugin_kafskonqplugin_h

#include <qstring.h>
#include <kpropertiesdialog.h>

class QFrame;
class QRadioButton;
class QLineEdit;
class QVGroupBox;
class QCheckBox;
class AFSPermsPage;
class QWidgetStack;

typedef char sec_rgy_name_t[1025];	/* A DCE definition */
#define MAXNAME 100

struct Acl {
    int dfs;	/* Originally true if a dfs acl; now also the type
		 of the acl (1, 2, or 3, corresponding to object,
		 initial dir, or initial object). */
    sec_rgy_name_t cell; /* DFS cell name */
    int nplus;
    int nminus;
    struct AclEntry *pluslist;
    struct AclEntry *minuslist;
};

struct AclEntry {
    struct AclEntry *next;
    char name[MAXNAME];
    unsigned long rights;
};

class KAFSPropertiesDialogPlugin : public KPropsDlgPlugin
{
    Q_OBJECT
    public:
      KAFSPropertiesDialogPlugin(KPropertiesDialog *dlg, const char *,
				 const QStringList &);
      virtual ~KAFSPropertiesDialogPlugin();

      virtual void applyChanges();

    public slots:
      virtual void displayUserPerms(const QString &, const int);
      virtual void setUserPerms(const QString &, const int, const int, const int);
      virtual void normPermChanged(int);
      virtual void negPermChanged(int);

    protected:

      KPropertiesDialog* propDialog;

      QFrame* page;

      AFSPermsPage* AFSPermWidget;

      /**  */
      struct Acl *thisAcl;

      QString dirPath;
      QString afsVolumeName;
      unsigned long afsVolumeID;
      unsigned long minQuota;
      unsigned long maxQuota;
      unsigned long blocksInUse;
      unsigned long partitionAvailBlocks;
      unsigned long partitionBlocks;

      void initValues(AFSPermsPage *thePage);
      void saveValuesToShare();
      void init();

      /**
       * Checks whether or not the entered Values are correct
       * @return false if not correct otherwise true
       */
      bool checkValues();

      AFSPermsPage* createAFSPermWidget(QWidget* parent);

    protected slots:

    private: // Private methods
      void getQuota(QString &path);

};


#endif
